



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++11 的右值引用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++11 的右值引用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 11:12:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>作者：Tinro<br />链接：https://www.zhihu.com/question/22111546/answer/30801982<br />来源：知乎<br />著作权归作者所有。商业转载请联系作者获得授权，非商业转载请注明出处。</p>
<div>
<div>
<div>
<div>
<div>
<p>右值引用是C++11中最重要的新特性之一，它解决了C++中大量的历史遗留问题，使C++标准库的实现在多种场景下消除了不必要的额外开销（如std::vector, std::string)，也使得另外一些标准库（如std::unique_ptr, std::function）成为可能。即使你并不直接使用右值引用，也可以通过标准库，间接从这一新特性中受益。为了更好的理解标准库结合右值引用带来的优化，我们有必要了解一下右值引用的重大意义。</p>
<p>右值引用的意义通常解释为两大作用：移动语义和完美转发。本文主要讨论移动语义。</p>
<p>移动语义<br />======</p>
<p>移动语义，简单来说解决的是各种情形下<strong>对象的资源所有权转移</strong>的问题。而在C++11之前，移动语义的缺失是C++饱受诟病的问题之一。</p>
<p>举个栗子。</p>
<p>问题一：如何将大象放入冰箱？<br />答案是众所周知的。首先你需要有一台特殊的冰箱，这台冰箱是为了装下大象而制造的。你打开冰箱门，将大象放入冰箱，然后关上冰箱门。</p>
<p>问题二：如何将大象从一台冰箱转移到另一台冰箱？<br />普通解答：打开冰箱门，取出大象，关上冰箱门，打开另一台冰箱门，放进大象，关上冰箱门。<br />2B解答：在第二个冰箱中启动量子复制系统，克隆一只完全相同的大象，然后启动高能激光将第一个冰箱内的大象气化消失。<br />等等，这个2B解答听起来很耳熟，这不就是C++中要<strong>移动</strong>一个对象时所做的事情吗？</p>
<p>&ldquo;移动&rdquo;，这是一个三岁小孩都明白的概念。将大象（资源）从一台冰箱（对象）<strong>移动</strong>到另一台冰箱，这个行为是如此自然，没有任何人会采用先复制大象，再销毁大象这样匪夷所思的方法。C++通过拷贝构造函数和拷贝赋值操作符为类设计了<strong>拷贝/复制</strong>的概念，但为了实现对资源的<strong>移动</strong>操作，调用者必须使用先复制、再析构的方式。否则，就需要自己实现移动资源的接口。</p>
<p>为了实现移动语义，首先需要解决的问题是，如何标识对象的资源是可以被移动的呢？这种机制必须以一种最低开销的方式实现，并且对所有的类都有效。C++的设计者们注意到，大多数情况下，<strong>右值</strong>所包含的对象都是可以<strong>安全的被移动</strong>的。</p>
<p><strong>右值</strong>（相对应的还有<strong>左值</strong>）是从C语言设计时就有的概念，但因为其如此基础，也是一个最常被忽略的概念。不严格的来说，左值对应变量的存储位置，而右值对应变量的值本身。C++中右值可以被赋值给左值或者绑定到引用。类的右值是一个临时对象，如果没有被绑定到引用，在表达式结束时就会被废弃。于是我们可以在右值被废弃之前，移走它的资源进行废物利用，从而避免无意义的复制。被移走资源的右值在废弃时已经成为空壳，析构的开销也会降低。</p>
<p><strong>右值中的数据可以被安全移走</strong>这一特性使得右值被用来表达移动语义。以同类型的右值构造对象时，需要以引用形式传入参数。右值引用顾名思义专门用来引用右值，左值引用和右值引用可以被分别重载，这样确保左值和右值分别调用到拷贝和移动的两种语义实现。对于左值，如果我们明确放弃对其资源的所有权，则可以通过std::move()来将其转为右值引用。std::move()实际上是static_cast&lt;T&amp;&amp;&gt;()的简单封装。</p>
<p>右值引用至少可以解决以下场景中的移动语义缺失问题：</p>
<ul><li>按值传入参数</li></ul>
<p>按值传参是最符合人类思维的方式。基本的思路是，如果传入参数是为了将资源交给函数接受者，就应该按值传参。同时，按值传参可以兼容任何的cv-qualified左值、右值，是兼容性最好的方式。</p>
<div>
<pre class="prettyprint linenums"><code>class People {<br />
public:<br />
  People(string name) // 按值传入字符串，可接收左值、右值。接收左值时为复制，接收右值时为移动<br />
  : name_(move(name)) // 显式移动构造，将传入的字符串移入成员变量<br />
  {<br />
  }<br />
  string name_;<br />
};

People a("Alice"); // 移动构造name

string bn = "Bob";<br />
People b(bn); // 拷贝构造name<br />
</code></pre>
</div>
<p>构造a时，调用了一次字符串的构造函数和一次字符串的移动构造函数。如果使用const string&amp; name接收参数，那么会有一次构造函数和一次拷贝构造，以及一次non-trivial的析构。尽管看起来很蛋疼，尽管编译器还有优化，但从语义来说按值传入参数是最优的方式。</p>
<p>如果你要在构造函数中接收std::shared_ptr&lt;X&gt;并且存入类的成员（这是非常常见的），那么按值传入更是不二选择。拷贝std::shared_ptr&lt;X&gt;需要线程同步，相比之下移动std::shared_ptr是非常轻松愉快的。</p>
<ul><li>按值返回</li></ul>
<p>和接收输入参数一样，返回值按值返回也是最符合人类思维的方式。曾经有无数函数为了返回容器而不得不写成这样</p>
<div>
<pre class="prettyprint linenums"><code>void str_split(const string&amp; s, vector&lt;string&gt;* vec); // 一个按值语义定义的字符串拆分函数。这里不考虑分隔符，假定分隔符是固定的。<br />
</code></pre>
</div>
<p>这样要求vec在外部被事先构造，此时尚无从得知vec的大小。即使函数内部有办法预测vec的大小，因为函数并不负责构造vec，很可能仍需要resize。<br />对这样的函数嵌套调用更是痛苦的事情，谁用谁知道啊。</p>
<p>有了移动语义，就可以写成这样</p>
<div>
<pre class="prettyprint linenums"><code>vector&lt;string&gt; str_split(const string&amp; s) {<br />
  vector&lt;string&gt; v;<br />
  // ...<br />
  return v; // v是左值，但优先移动，不支持移动时仍可复制。<br />
}<br />
</code></pre>
</div>
<p>如果函数按值返回，return语句又直接返回了一个栈上的左值对象（输入参数除外）时，标准要求优先调用移动构造函数，如果不符再调用拷贝构造函数。尽管v是左值，仍然会优先采用移动语义，返回vector&lt;string&gt;从此变得云淡风轻。此外，无论移动或是拷贝，可能的情况下仍然适用编译器优化，但语义不受影响。</p>
<p>对于std::unique_ptr来说，这简直就是福音。</p>
<div>
<pre class="prettyprint linenums"><code>unique_ptr&lt;SomeObj&gt; create_obj(/*...*/) {<br />
  unique_ptr&lt;SomeObj&gt; ptr(new SomeObj(/*...*/));<br />
  ptr-&gt;foo(); // 一些可能的初始化<br />
  return ptr;<br />
}<br />
</code></pre>
</div>
<p>当然还有更简单的形式</p>
<div>
<pre class="prettyprint linenums"><code>unique_ptr&lt;SomeObj&gt; create_obj(/*...*/) {<br />
  return unique_ptr&lt;SomeObj&gt;(new SomeObj(/*...*/));<br />
}<br />
</code></pre>
</div>
<p>在工厂类中，这样的语义是非常常见的。返回unique_ptr能够明确对所构造对象的所有权转移，特别的，这样的工厂类返回值可以被忽略而不会造成内存泄露。上面两种形式分别返回栈上的左值和右值，但都适用移动语义（unique_ptr不支持拷贝）。</p>
<ul><li>接收右值表达式</li></ul>
<p>没有移动语义时，以表达式的值（例为函数调用）初始化对象或者给对象赋值是这样的：</p>
<div>
<pre class="prettyprint linenums"><code>vector&lt;string&gt; str_split(const string&amp; s);

vector&lt;string&gt; v = str_split("1,2,3"); // 返回的vector用以拷贝构造对象v。为v申请堆内存，复制数据，然后析构临时对象（释放堆内存）。<br />
vector&lt;string&gt; v2;<br />
v2 = str_split("1,2,3"); // 返回的vector被复制给对象v（拷贝赋值操作符）。需要先清理v2中原有数据，将临时对象中的数据复制给v2，然后析构临时对象。<br />
</code></pre>
</div>
<p>注：v的拷贝构造调用有可能被优化掉，尽管如此在<strong>语义上</strong>仍然是有一次拷贝操作。</p>
<p>同样的代码，在支持移动语义的世界里就变得更美好了。</p>
<div>
<pre class="prettyprint linenums"><code>vector&lt;string&gt; str_split(const string&amp; s);

vector&lt;string&gt; v = str_split("1,2,3"); // 返回的vector用以移动构造对象v。v直接取走临时对象的堆上内存，无需新申请。之后临时对象成为空壳，不再拥有任何资源，析构时也无需释放堆内存。<br />
vector&lt;string&gt; v2;<br />
v2 = str_split("1,2,3"); // 返回的vector被移动给对象v（移动赋值操作符）。先释放v2原有数据，然后直接从返回值中取走数据，然后返回值被析构。<br />
</code></pre>
</div>
<p>注：v的移动构造调用有可能被优化掉，尽管如此在<strong>语义上</strong>仍然是有一次移动操作。</p>
<p>不用多说也知道上面的形式是多么常用和自然。而且这里完全没有任何对右值引用的显式使用，性能提升却默默的实现了。</p>
<ul><li>对象存入容器</li></ul>
<p>这个问题和前面的构造函数传参是类似的。不同的是这里是按两种引用分别传参。参见std::vector的push_back函数。</p>
<div>
<pre class="prettyprint linenums"><code>void push_back( const T&amp; value ); // (1)<br />
void push_back( T&amp;&amp; value ); // (2)<br />
</code></pre>
</div>
<p>不用多说自然是左值调用1右值调用2。如果你要往容器内放入超大对象，那么版本2自然是不2选择。</p>
<div>
<pre class="prettyprint linenums"><code>vector&lt;vector&lt;string&gt;&gt; vv;

vector&lt;string&gt; v = {"123", "456"};<br />
v.push_back("789"); // 临时构造的string类型右值被移动进容器v<br />
vv.push_back(move(v)); // 显式将v移动进vv<br />
</code></pre>
</div>

<p>困扰多年的难言之隐是不是一洗了之了？</p>
<ul><li>std::vector的增长</li></ul>
<p>又一个隐蔽的优化。当vector的存储容量需要增长时，通常会重新申请一块内存，并把原来的内容一个个复制过去并删除。对，复制并删除，改用移动就够了。</p>
<p>对于像vector&lt;string&gt;这样的容器，如果频繁插入造成存储容量不可避免的增长时，移动语义可以带来悄无声息而且美好的优化。</p>
<ul><li>std::unique_ptr放入容器</li></ul>
<p>曾经，由于vector增长时会复制对象，像std::unique_ptr这样不可复制的对象是无法放入容器的。但实际上vector并不复制对象，而只是&ldquo;移动&rdquo;对象。所以随着移动语义的引入，std::unique_ptr放入std::vector成为理所当然的事情。</p>
<p>容器中存储std::unique_ptr有太多好处。想必每个人都写过这样的代码：</p>
<div>
<pre class="prettyprint linenums"><code>MyObj::MyObj() {<br />
  for (...) {<br />
    vec.push_back(new T());<br />
  }<br />
  // ...<br />
}

MyObj::~MyObj() {<br />
  for (vector&lt;T*&gt;::iterator iter = vec.begin(); iter != vec.end(); ++iter) {<br />
    if (*iter) delete *iter;<br />
  }<br />
  // ...<br />
}<br />
</code></pre>
</div>

<p>繁琐暂且不说，异常安全也是大问题。使用vector&lt;unique_ptr&lt;T&gt;&gt;，完全无需显式析构，unqiue_ptr自会打理一切。完全不用写析构函数的感觉，你造吗？</p>
<p>unique_ptr是非常轻量的封装，存储空间等价于裸指针，但安全性强了一个世纪。实际中需要共享所有权的对象（指针）是比较少的，但需要转移所有权是非常常见的情况。auto_ptr的失败就在于其转移所有权的繁琐操作。unique_ptr配合移动语义即可轻松解决所有权传递的问题。</p>
<p>注：如果真的需要共享所有权，那么基于引用计数的shared_ptr是一个好的选择。shared_ptr同样可以移动。由于不需要线程同步，移动shared_ptr比复制更轻量。</p>
<ul><li>std::thread的传递</li></ul>
<p>thread也是一种典型的不可复制的资源，但可以通过移动来传递所有权。同样std::future std::promise std::packaged_task等等这一票多线程类都是不可复制的，也都可以用移动的方式传递。</p>
<p>完美转发<br />======<br />除了移动语义，右值引用还解决了C++03中引用语法无法转发右值的问题，实现了完美转发，才使得std::function能有一个优雅的实现。这部分不再展开了。</p>
<p>总结<br />======</p>
<p>移动语义绝不是语法糖，而是带来了C++的深刻革新。移动语义不仅仅是针对库作者的，任何一个程序员都有必要去了解它。尽管你可能不会去主动为自己的类实现移动语义，但却时时刻刻都在享受移动语义带来的受益。因此这绝不意味着这是一个可有可无的东西。</p></div>
<div>
<div><a href="/question/22111546/answer/30801982" rel="external nofollow noreferrer">编辑于 2016-05-23</a></div>
</div>
<div>
<div>​赞同 984​​68 条评论</p>
<div>
<div>​分享</div>
</div>
<p>​收藏​感谢</p>
<div>​</div>
<p>收起</p></div>
<div>&nbsp;</div>
</div>
</div>
</div>
</div>
<div>
<div>
<div>
<div>
<div>
<div><img referrerpolicy="no-referrer"src="https://pic3.zhimg.com/fec53e05a44892fd37969d33047661ee_xs.jpg" /></div>
</div>
<div>
<div>
<div>
<div><a href="//www.zhihu.com/people/yayj" rel="external nofollow noreferrer">zihuatanejo</a></div>
</div>
</div>
<div>
<div>
<div>重度强迫症</div>
</div>
</div>
</div>
</div>
<div>67 人赞同了该回答</div>
</div>
<div>
<div>
<p>一句话答案：右值引用的出现是为了实现移动语义，顺便解决完美转发的问题，其意义在于扩充了值语义，帮助Modern C++可以全面地应用RAII。</p>
<p>以下展开:<br />------------------------</p>
<ul><li>澄清误区</li></ul>

<p>在具体回答右值引用的价值之前，我想先否定题主的两个提法。</p>
<p>首先是</p>
<blockquote><p>"<em>将这样一个问题留给程序员解决</em>"</p></blockquote>
<p>右值引用并没有将什么&ldquo;<strong>问题</strong>&rdquo;留给程序员解决，而是<strong>向程序员提供更多的选择</strong>。正如Bjarne Stroustrup所说，</p>
<blockquote><p>"<em>C++的许多设计决策根源于我对强迫人按某种特定方式行事的极度厌恶。</em>"<br />"<em>当我试图去取缔一个我不喜欢的语言特征时，我总抑制住这样的欲望，因为我认为我无权把个人观点强加给别人。</em>"</p></blockquote>
<p>选择是自主权的表现，向往自由的人一定不会认为有选择是件坏事。</p>
<p>更何况右值引用的神奇之处在于，在很多时候，使用函数库的程序员根本不用关心它的存在。例如：</p>
<div>
<pre class="prettyprint linenums"><code>auto vec = init_data(args);<br />
auto pi  = make_shared&lt;int&gt;(11);<br />
auto ei  = resolver.resolve({"localhost", "1024"});<br />
</code></pre>
</div>
<p>另一个是</p>
<blockquote><p>"<em>一种缺乏GC机制的语言为了性能的必要折衷</em>"</p></blockquote>

<p>由于有<a href="http://zh.wikipedia.org/wiki/RAII" rel="external nofollow noreferrer">RAII</a>的存在，<a href="http://herbsutter.com/2014/05/21/cppcon-my-proposed-talks-part-2/" rel="external nofollow noreferrer">C++通常是不需要GC的</a>，因为RAII能让C++代码同时具备<strong>简洁</strong>、<strong>高性能</strong>(<em>在某些特定的高并发环境里GC性能可能更高</em>)和<strong>异常安全</strong>这三个特点。所以，C++暂时还不需要任何特性来作这种所谓的折衷。</p>
<ul><li>为什么会觉得右值引用很怪？</li></ul>

<p>根本原因是<strong>不理解值语义(Value Semantics)</strong>。</p>
<p><a href="http://www.parashift.com/c++-faq/val-vs-ref-semantics.html" rel="external nofollow noreferrer">值语义</a>是很多OO语言里没有的概念。在这些语言里，几乎所有的变量都是引用语义(Reference Semantics)，GC掌管了所有对象的生命期管理事务， 程序员无需为此操心，只需要用变量去对象池中去引用即可。值语义虽然也有出场的机会，例如Java里的<a href="http://docs.oracle.com/javase/tutorial/java/nutsandbolts/datatypes.htmlPrimitive" rel="external nofollow noreferrer">Primitive Data Type</a>，但毕竟不是重点，所以往往被忽视。</p>
<p>还有一个很重要的原因，在OO语言里，</p>
<blockquote><p><a href="http://akrzemi1.wordpress.com/2012/02/03/value-semantics/#comment-270" rel="external nofollow noreferrer">值语义和运行时多态是矛盾的。</a></p></blockquote>
<p>值语义因此也成为了C++区别于其它OO语言的特征之一。</p>
<p>所以，在不理解值语义的情况下去谈右值引用，最多也是浅尝辄止，所以"感觉奇怪"也是很正常的，甚至会出现类似<a href="http://coolshell.cn/articles/9543.html" rel="external nofollow noreferrer">&ldquo;C++的数组不支持多态&rdquo;？</a>这样的问题。</p>
<ul><li>值语义的作用</li></ul>

<p>首先给出一篇<a href="http://akrzemi1.wordpress.com/2012/02/03/value-semantics/" rel="external nofollow noreferrer">blog</a>作为值语义的科普，内容则不再复述，以下只讨论其意义。</p>
<p>这篇blog的作者<a href="https://github.com/akrzemi1" rel="external nofollow noreferrer">Andrzej Krzemieński</a>，曾在另一篇blog中盛赞RAII，并认为它是<a href="http://akrzemi1.wordpress.com/2013/07/18/cs-best-feature/" rel="external nofollow noreferrer">C++'s best feature</a>，<a href="http://herbsutter.com/about/" rel="external nofollow noreferrer">Herb Sutter</a>也在<a href="http://akrzemi1.wordpress.com/2013/07/18/cs-best-feature/#comment-1424" rel="external nofollow noreferrer">文章的回复</a>中提到:</p>
<blockquote><p>RAII code is just naturally exception-safe with immediate cleanup, not leaking stuff until the GC gets around to finding it. This is especially important with scarce resources like file handles.</p></blockquote>

<p>但问题是，像C#的<a href="http://msdn.microsoft.com/en-us/library/yh598w02%28v=vs.80%29.aspx" rel="external nofollow noreferrer">using statement</a>和Java的<a href="http://docs.oracle.com/javase/tutorial/essential/exceptions/tryResourceClose.html" rel="external nofollow noreferrer">try-with-resources statement</a>同样具有RAII的特点，但仍然有人会提出<a href="http://swiftcoder.wordpress.com/2009/02/18/raii-why-is-it-unique-to-c/" rel="external nofollow noreferrer">"RAII: Why is unique to C++?"</a>这样的问题。原因即在于C++独有的值语义：<strong>程序员通过</strong><strong>值语义可以方便直观地控制对象生命期，让RAII用起来更自然。</strong></p>
<p>更何况像这段代码，</p>
<div>
<pre class="prettyprint linenums"><code>vector&lt;ifstream&gt; produce()<br />
{<br />
  vector&lt;ifstream&gt; ans;<br />
  for (int i = 0;  i &lt; 10; ++i) {<br />
    ans.emplace_back(name(i));<br />
  }<br />
  return ans;<br />
}

void consumer()<br />
{<br />
  vector&lt;ifstream&gt; files = produce();<br />
  for (ifstream&amp; f: files) {<br />
    read(f);<br />
  }<br />
}<br />
</code></pre>
</div>
<p>用try-with-resources根本就搞不定。当然，finally还是可以搞定，只是代码会很丑。</p>
<p>所以，值语义在C++里的作用之一就是用于控制对象生命期(<a href="http://blog.csdn.net/Solstice/article/details/6692976" rel="external nofollow noreferrer">另一个作用就是提升性能</a>)，以方便通过RAII写出简洁自然、异常安全的代码。该意义非常重大，这也是右值引用在<a href="http://www2.open-std.org/jtc1/sc22/wg21/docs/papers/2007/n2291.html" rel="external nofollow noreferrer">C++ - State of the Evolution</a>上稳坐头把交椅的原因。</p>
<ul><li>右值引用与值语义</li></ul>
<p>前面提到，值语义用于控制对象的生命期，而其具体的控制方式分为两种：</p>
<ul><li>生命期限于scope内：无需控制，到期自动调用析构函数。</li>
<li>需要延长到scope外：移动语义。</li></ul>
<p>因为右值引用的目的在于<a href="http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2006/n2027.html#rvalue_reference" rel="external nofollow noreferrer">实现移动语义</a>，所以右值引用 意义即是<strong>加强了值语义对对象生命期的控制能力</strong>。</p>
<p>在移动语义的作用下，<a href="http://book.douban.com/subject/1231590/" rel="external nofollow noreferrer">Effective C++</a> 条款23从此作古：</p>
<blockquote><p>当你必须传回object时，不要尝试传回reference。</p></blockquote>
<p>资源管理类，如<a href="http://en.cppreference.com/w/cpp/io/basic_ifstream" rel="external nofollow noreferrer">std::ifstream</a>、<a href="http://www.boost.org/doc/libs/1_56_0/doc/html/boost_asio/reference/basic_stream_socket.html" rel="external nofollow noreferrer">boost::asio::basic_stream_socket</a>，可以光明正大地当成int来用，而无需担心类似<a href="http://book.douban.com/subject/1792179/" rel="external nofollow noreferrer">Effective STL</a> 条款8那样的问题：</p>
<blockquote><p>切勿创建包含auto_ptr的容器对象。</p></blockquote>

<ul><li>右值引用与完美转发</li></ul>

<p>右值引用还有一个作用是实现完美转发。<a href="http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2002/n1385.htm" rel="external nofollow noreferrer">完美转发可以在一定程度上让代码保持简洁</a>，但同时，这也引入了一些<a href="http://scottmeyers.blogspot.com/2012/10/copying-constructors-in-c11.html" rel="external nofollow noreferrer">令人讨厌的坑</a>。个人感觉意义不如移动语义的重大，所以这里不再展开了。</p>
<p>---------------<br />附参考资料</p>
<ul><li><a href="http://www.meetingcpp.com/index.php/br/items/cpp-future-and-the-pointer.html" rel="external nofollow noreferrer">C++ future and the pointer</a>. Jens Weller</li>
<li><a href="https://github.com/CppCon/CppCon2014/blob/master/Presentations/Back%20to%20the%20Basics!%20Essentials%20of%20Modern%20C++%20Style/Back%20to%20the%20Basics!%20Essentials%20of%20Modern%20C++%20Style%20-%20Herb%20Sutter%20-%20CppCon%202014.pdf?raw=true" rel="external nofollow noreferrer">Back to the Basics! Essentials of Modern C++ Style</a>. Herb Sutter</li>
<li><a href="http://akrzemi1.wordpress.com/2011/08/11/move-constructor/" rel="external nofollow noreferrer">Move Constructor</a>. Andrzej Krzemieński</li>
<li><a href="http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2002/n1377.htm" rel="external nofollow noreferrer">A proposal to Add Move Semantics Support to C++ Language</a>. Howard E. Hinnant, Peter Dimov, Dave Abrahams</li>
<li><a href="http://www.cnblogs.com/solstice/archive/2011/08/16/2141515.html" rel="external nofollow noreferrer">C++ 工程实践(8)：值语义</a>. 陈硕</li></ul>
</div>
</div>
</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96203q4.html">Python标准模块--threading</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7zldj9.html">关于目录路径path</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdw3r79.html">GROUP函数-GROUP&lowbar;ID&comma;GROUPING&comma;GROUPING&lowbar;ID</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7vkdjq.html">ACM&colon;  POJ 3259 Wormholes - SPFA负环判定</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2pvw38.html">Android&mdash;&mdash;五大布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ky7n59.html">BZOJ 1066 POJ 2711 &lbrack;SCOI2007&rsqb;蜥蜴</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdvzgz8.html">给Mac下的iTerm2增加配色</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnlgxrq.html">Codeforces Round &num;337 &lpar;Div&period; 2&rpar; C&period; Harmony Analysis 构造</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j027e4q.html">模拟在table中移动鼠标，高亮显示鼠标所在行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgg0xq.html">迁移web&period;py项目至git&commat;osc的项目演示平台</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m33ljq.html">Linux内核系列之Block块层（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0yoz0q.html">C&num;WebService 客户端通过Http调用请求（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ye0l0q.html">codility上的练习（5）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9500ovm8.html">Eclipse 发布到网站的附加产品的形式 Update Site</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpj5p39.html">view components介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7znpnk9.html">Caffe学习系列（四）之--训练自己的模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geg4d08.html">Python执行系统命令：使用subprocess的Popen函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/950v4ve8.html">Eslint报错整理与解决方法（持续整理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyy7619.html">leetcode &mdash; trapping-rain-water</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy3p62q.html">【LeetCode每天一题】Trapping Rain Water&lpar;获得雨水的容量&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/963lon49.html">&lbrack;转&rsqb;SQL Server如何启用xp&lowbar;cmdshell组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e2m5e9.html">&lbrack;转&rsqb;数据库中Schema（模式）概念的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlnjmk9.html">利用jquery&period;backstretch插件，背景切换</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vyrm6q.html">如何利用gulp构建前端自动化</a>
			</li>
						<li><a href="https://www.batexi.com/a/93p3jjg8.html">CRC算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv620jq.html">【5】Builder模式（构建者模式）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93p3dkz8.html">Tips&mdash;&mdash;canvas闪屏问题的处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kok5m5q.html">package&period;json中devDependencies与dependencies的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx26eov8.html">JS全局变量VAR和THIS--在函数内部，加var是局部变量，不加是全局变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/93p3vvg8.html">github&vert;webstorm</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
